"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RealRenderer = exports.RealRendererTypes = void 0;
var eventEmitter_1 = require("./events/eventEmitter");
var RealRendererEvents_1 = require("../../constants/events/RealRendererEvents");
var blankGraph_1 = require("../../pathMakers/blankGraph");
exports.RealRendererTypes = require("../../types/RealRendererTypes");
var RealRendererDefaults_1 = require("../../constants/defaults/RealRendererDefaults");
__exportStar(require("../../constants/defaults/RealRendererDefaults"), exports);
var undo_1 = require("./undo");
var import_export_1 = require("./import-export");
var background_1 = require("./background");
var svg_dom_1 = require("./svg/svg-dom");
var svg_settings_1 = require("./svg/svg-settings");
var draw_1 = require("./draw/draw");
var render_1 = require("./draw/render");
/**
 * General Real Renderer with no specific purpose. Should be extended to use.
 */
var RealRenderer = /** @class */ (function (_super) {
    __extends(RealRenderer, _super);
    /**
     *
     * @param options
     * @param eventList
     */
    function RealRenderer(options, eventList) {
        if (eventList === void 0) { eventList = RealRendererEvents_1.RealRendererEventList; }
        var _this = _super.call(this, eventList) || this;
        _this._offsetX = 0;
        _this._offsetY = 0;
        _this.strokes = [];
        _this._strokeIndex = -1;
        _this.undo = undo_1.undo;
        _this.redo = undo_1.redo;
        _this.exportData = import_export_1.exportData;
        _this.importData = import_export_1.importData;
        _this.changeBackground = background_1.changeBackground;
        _this.scale = svg_settings_1.scale;
        _this.changeOffsets = svg_settings_1.changeOffsets;
        _this.attach = svg_dom_1.attach;
        _this.draw = draw_1.draw;
        _this.startRender = render_1.startRender;
        _this.stopRender = render_1.stopRender;
        _this.toggleRender = render_1.toggleRender;
        _this.normalizeBG = background_1.normalizeBG;
        _this._setSVG = svg_dom_1._setSVG;
        _this._setViewBox = svg_dom_1._setViewBox;
        _this._drawFunc = draw_1._drawFunc;
        _this._draw = draw_1._draw;
        _this._display = draw_1._display;
        _this._addStroke = draw_1._addStroke;
        _this._render = render_1._render;
        // *****DEFAULTS*****
        _this.settings = __assign(__assign({}, RealRendererDefaults_1.RealRendererDefaults), options);
        _this.bgType = _this.settings.bgType;
        _this.normalizeBG();
        _this.bgColor = _this.settings.bgColor;
        _this.drawsPerFrame = _this.settings.drawsPerFrame;
        _this.timeStep = _this.settings.timeStep;
        _this.time = _this.settings.initTime;
        _this.scaleFactor = _this.settings.scaleFactor;
        return _this;
        // *****DEFAULTS*****
    }
    /**
     * Resets the internal time counter.
     * @returns Self for chaining.
     */
    RealRenderer.prototype.resetTime = function () {
        this.time = 0;
        return this;
    };
    /**
     * Resets everything regarding the graph.
     * @returns Self for chaining.
     */
    RealRenderer.prototype.reset = function () {
        this.strokes = [
            blankGraph_1.getBlankGraphPaths(this.dimensions, this.bgColor, this.bgType)
        ];
        this._strokeIndex = 0;
        this.resetTime();
        this._display(this.strokes[this._strokeIndex]);
        return this;
    };
    return RealRenderer;
}(eventEmitter_1.EventEmitter));
exports.RealRenderer = RealRenderer;
