"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._addStroke = exports._display = exports.draw = exports._draw = exports._drawFunc = void 0;
function _drawFunc(time) {
    return this;
}
exports._drawFunc = _drawFunc;
function _draw() {
    this.time += this.timeStep;
    this._drawFunc(this.time);
    return this;
}
exports._draw = _draw;
/**
 * Draw a certain number of frames.
 * @param numDraws Number of frames to draw.
 * @returns Self for chaining.
 */
function draw(numDraws) {
    if (numDraws === void 0) { numDraws = 1; }
    for (var i = 0; i < numDraws; i++)
        this._draw();
    return this;
}
exports.draw = draw;
function _display(stroke) {
    var _this = this;
    stroke.forEach(function (strokeNode) {
        if (strokeNode.node.parentElement == null)
            _this.svgSections[strokeNode.section].appendChild(strokeNode.node);
    });
}
exports._display = _display;
function _addStroke(stroke) {
    if (this.strokes.length > this._strokeIndex + 1)
        this.strokes.splice(this._strokeIndex + 1, this.strokes.length - this._strokeIndex);
    this.strokes[++this._strokeIndex] = stroke;
}
exports._addStroke = _addStroke;
