"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toggleRender = exports.stopRender = exports.startRender = exports._render = void 0;
function _render() {
    var _this = this;
    if (this._doRender) {
        this.draw(this.drawsPerFrame);
        this._display(this.strokes[this._strokeIndex]);
        window.requestAnimationFrame(function () { _this._render(); });
    }
}
exports._render = _render;
/**
 * Start rendering.
 * @returns Self for chaining.
 */
function startRender() {
    if (!this._doRender) {
        this._doRender = true;
        this._render();
        this.emit('start-render', {});
    }
    return this;
}
exports.startRender = startRender;
/**
 * Stop rendering.
 * @returns Self for chaining.
 */
function stopRender() {
    this._doRender = false;
    this.emit('stop-render', {});
    return this;
}
exports.stopRender = stopRender;
/**
 * Toggle rendering.
 * @returns Self for chaining.
 */
function toggleRender() {
    this._doRender = !this._doRender;
    if (this._doRender)
        this._render();
    return this;
}
exports.toggleRender = toggleRender;
