import { RealExport } from '../../types/RealRendererTypes';
import { RealRenderer } from './RealRenderer';
/**
 * Export the data of the graph in a certain format that can be used to load the data later. Load using .importData().
 * @returns Data of the graph in a storable and loadable format.
 */
export declare function exportData(this: RealRenderer): RealExport;
/**
 * Import the data exported by .export() method.
 * @param data Data exported by .export()
 * @returns Self for chaining.
 */
export declare function importData(this: RealRenderer, data: RealExport): RealRenderer<import("../../constants/events/RealRendererEvents").IRealRendererEvents>;
